/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the ActivateOrBlockIdentityResponse type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ActivateOrBlockIdentityResponse{}

// ActivateOrBlockIdentityResponse struct for ActivateOrBlockIdentityResponse
type ActivateOrBlockIdentityResponse struct {
	Identity *Identity                        `json:"identity,omitempty"`
	Accounts []ActivateOrBlockAccountResponse `json:"accounts,omitempty"`
}

// NewActivateOrBlockIdentityResponse instantiates a new ActivateOrBlockIdentityResponse object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewActivateOrBlockIdentityResponse() *ActivateOrBlockIdentityResponse {
	this := ActivateOrBlockIdentityResponse{}
	return &this
}

// NewActivateOrBlockIdentityResponseWithDefaults instantiates a new ActivateOrBlockIdentityResponse object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewActivateOrBlockIdentityResponseWithDefaults() *ActivateOrBlockIdentityResponse {
	this := ActivateOrBlockIdentityResponse{}
	return &this
}

// GetIdentity returns the Identity field value if set, zero value otherwise.
func (o *ActivateOrBlockIdentityResponse) GetIdentity() Identity {
	if o == nil || IsNil(o.Identity) {
		var ret Identity
		return ret
	}
	return *o.Identity
}

// GetIdentityOk returns a tuple with the Identity field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ActivateOrBlockIdentityResponse) GetIdentityOk() (*Identity, bool) {
	if o == nil || IsNil(o.Identity) {
		return nil, false
	}
	return o.Identity, true
}

// HasIdentity returns a boolean if a field has been set.
func (o *ActivateOrBlockIdentityResponse) HasIdentity() bool {
	if o != nil && !IsNil(o.Identity) {
		return true
	}

	return false
}

// SetIdentity gets a reference to the given Identity and assigns it to the Identity field.
func (o *ActivateOrBlockIdentityResponse) SetIdentity(v Identity) {
	o.Identity = &v
}

// GetAccounts returns the Accounts field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *ActivateOrBlockIdentityResponse) GetAccounts() []ActivateOrBlockAccountResponse {
	if o == nil {
		var ret []ActivateOrBlockAccountResponse
		return ret
	}
	return o.Accounts
}

// GetAccountsOk returns a tuple with the Accounts field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *ActivateOrBlockIdentityResponse) GetAccountsOk() ([]ActivateOrBlockAccountResponse, bool) {
	if o == nil || IsNil(o.Accounts) {
		return nil, false
	}
	return o.Accounts, true
}

// HasAccounts returns a boolean if a field has been set.
func (o *ActivateOrBlockIdentityResponse) HasAccounts() bool {
	if o != nil && !IsNil(o.Accounts) {
		return true
	}

	return false
}

// SetAccounts gets a reference to the given []ActivateOrBlockAccountResponse and assigns it to the Accounts field.
func (o *ActivateOrBlockIdentityResponse) SetAccounts(v []ActivateOrBlockAccountResponse) {
	o.Accounts = v
}

func (o ActivateOrBlockIdentityResponse) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ActivateOrBlockIdentityResponse) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Identity) {
		toSerialize["identity"] = o.Identity
	}
	if o.Accounts != nil {
		toSerialize["accounts"] = o.Accounts
	}
	return toSerialize, nil
}

type NullableActivateOrBlockIdentityResponse struct {
	value *ActivateOrBlockIdentityResponse
	isSet bool
}

func (v NullableActivateOrBlockIdentityResponse) Get() *ActivateOrBlockIdentityResponse {
	return v.value
}

func (v *NullableActivateOrBlockIdentityResponse) Set(val *ActivateOrBlockIdentityResponse) {
	v.value = val
	v.isSet = true
}

func (v NullableActivateOrBlockIdentityResponse) IsSet() bool {
	return v.isSet
}

func (v *NullableActivateOrBlockIdentityResponse) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableActivateOrBlockIdentityResponse(val *ActivateOrBlockIdentityResponse) *NullableActivateOrBlockIdentityResponse {
	return &NullableActivateOrBlockIdentityResponse{value: val, isSet: true}
}

func (v NullableActivateOrBlockIdentityResponse) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableActivateOrBlockIdentityResponse) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
